<?php
/*
# ------------------------------------------------------------------------
# Vina Tag Cloud for K2 for Joomla 3
# ------------------------------------------------------------------------
# Copyright(C) 2014 www.VinaGecko.com. All Rights Reserved.
# @license http://www.gnu.org/licenseses/gpl-3.0.html GNU/GPL
# Author: VinaGecko.com
# Websites: http://vinagecko.com
# Forum: http://vinagecko.com/forum/
# ------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');
require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'utilities.php');

class modVinaTagCloudK2Helper
{
	public static function tagCloud(&$params)
	{
		$mainframe 	= JFactory::getApplication();
		$user 		= JFactory::getUser();
		$aid 		= (int)$user->get('aid');
		$db 		= JFactory::getDBO();
		$jnow 		= JFactory::getDate();
		$now 		= K2_JVERSION == '15' ? $jnow->toMySQL() : $jnow->toSql();
		$nullDate 	= $db->getNullDate();

		$query = "SELECT i.id FROM #__k2_items as i";
		$query .= " LEFT JOIN #__k2_categories c ON c.id = i.catid";
		$query .= " WHERE i.published=1 ";
		$query .= " AND ( i.publish_up = ".$db->Quote($nullDate)." OR i.publish_up <= ".$db->Quote($now)." ) ";
		$query .= " AND ( i.publish_down = ".$db->Quote($nullDate)." OR i.publish_down >= ".$db->Quote($now)." )";
		$query .= " AND i.trash=0 ";
		if (K2_JVERSION != '15')
		{
			$query .= " AND i.access IN(".implode(',', $user->getAuthorisedViewLevels()).") ";
		}
		else
		{
			$query .= " AND i.access <= {$aid} ";
		}
		$query .= " AND c.published=1 ";
		$query .= " AND c.trash=0 ";
		if (K2_JVERSION != '15')
		{
			$query .= " AND c.access IN(".implode(',', $user->getAuthorisedViewLevels()).") ";
		}
		else
		{
			$query .= " AND c.access <= {$aid} ";
		}

		$cloudCategory = $params->get('cloud_category');
		if (is_array($cloudCategory))
		{
			$cloudCategory = array_filter($cloudCategory);
		}
		if ($cloudCategory)
		{
			if (!is_array($cloudCategory))
			{
				$cloudCategory = (array)$cloudCategory;
			}
			foreach ($cloudCategory as $cloudCategoryID)
			{
				$categories[] = $cloudCategoryID;
				if ($params->get('cloud_category_recursive'))
				{
					$children = modVinaTagCloudK2Helper::getCategoryChildren($cloudCategoryID);
					$categories = @array_merge($categories, $children);
				}
			}
			$categories = @array_unique($categories);
			JArrayHelper::toInteger($categories);
			if (count($categories) == 1)
			{
				$query .= " AND i.catid={$categories[0]}";
			}
			else
			{
				$query .= " AND i.catid IN(".implode(',', $categories).")";
			}
		}

		if (K2_JVERSION != '15')
		{
			if ($mainframe->getLanguageFilter())
			{
				$languageTag = JFactory::getLanguage()->getTag();
				$query .= " AND c.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').") AND i.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').") ";
			}
		}

		$db->setQuery($query);
		$IDs = K2_JVERSION == '30' ? $db->loadColumn() : $db->loadResultArray();

		if (!is_array($IDs) || !count($IDs))
		{
			return array();
		}

		$query = "SELECT tag.name, tag.id
        FROM #__k2_tags as tag
        LEFT JOIN #__k2_tags_xref AS xref ON xref.tagID = tag.id 
        WHERE xref.itemID IN (".implode(',', $IDs).") 
        AND tag.published = 1";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$cloud = array();
		if (count($rows))
		{

			foreach ($rows as $tag)
			{

				if (@array_key_exists($tag->name, $cloud))
				{
					$cloud[$tag->name]++;
				}
				else
				{
					$cloud[$tag->name] = 1;
				}
			}

			$max_size = $params->get('max_size');
			$min_size = $params->get('min_size');
			$max_qty = max(array_values($cloud));
			$min_qty = min(array_values($cloud));
			$spread = $max_qty - $min_qty;
			if (0 == $spread)
			{
				$spread = 1;
			}

			$step = ($max_size - $min_size) / ($spread);

			$counter = 0;
			arsort($cloud, SORT_NUMERIC);
			$cloud = @array_slice($cloud, 0, $params->get('cloud_limit'), true);
			uksort($cloud, "strnatcasecmp");

			foreach ($cloud as $key => $value)
			{
				$size = $min_size + (($value - $min_qty) * $step);
				$size = ceil($size);
				$tmp = new stdClass;
				$tmp->tag = $key;
				$tmp->count = $value;
				$tmp->size = $size;
				$tmp->link = urldecode(JRoute::_(K2HelperRoute::getTagRoute($key)));
				$tags[$counter] = $tmp;
				$counter++;
			}

			return $tags;
		}
	}
	
	public static function getCategoryChildren($catid)
	{

		static $array = array();
		$mainframe = JFactory::getApplication();
		$user = JFactory::getUser();
		$aid = (int)$user->get('aid');
		$catid = (int)$catid;
		$db = JFactory::getDBO();
		$query = "SELECT * FROM #__k2_categories WHERE parent={$catid} AND published=1 AND trash=0 ";
		if (K2_JVERSION != '15')
		{
			$query .= " AND access IN(".implode(',', $user->getAuthorisedViewLevels()).") ";
			if ($mainframe->getLanguageFilter())
			{
				$languageTag = JFactory::getLanguage()->getTag();
				$query .= " AND language IN (".$db->Quote($languageTag).", ".$db->Quote('*').") ";
			}
		}
		else
		{
			$query .= " AND access <= {$aid}";
		}
		$query .= " ORDER BY ordering ";

		$db->setQuery($query);
		$rows = $db->loadObjectList();
		if ($db->getErrorNum())
		{
			echo $db->stderr();
			return false;
		}
		foreach ($rows as $row)
		{
			array_push($array, $row->id);
			if (modVinaTagCloudK2Helper::hasChildren($row->id))
			{
				modVinaTagCloudK2Helper::getCategoryChildren($row->id);
			}
		}
		return $array;
	}
	
	public static function hasChildren($id)
	{

		$mainframe = JFactory::getApplication();
		$user = JFactory::getUser();
		$aid = (int)$user->get('aid');
		$id = (int)$id;
		$db = JFactory::getDBO();
		$query = "SELECT * FROM #__k2_categories  WHERE parent={$id} AND published=1 AND trash=0 ";
		if (K2_JVERSION != '15')
		{
			$query .= " AND access IN(".implode(',', $user->getAuthorisedViewLevels()).") ";
			if ($mainframe->getLanguageFilter())
			{
				$languageTag = JFactory::getLanguage()->getTag();
				$query .= " AND language IN (".$db->Quote($languageTag).", ".$db->Quote('*').") ";
			}

		}
		else
		{
			$query .= " AND access <= {$aid}";
		}

		$db->setQuery($query);
		$rows = $db->loadObjectList();
		if ($db->getErrorNum())
		{
			echo $db->stderr();
			return false;
		}

		if (count($rows))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public static function getCopyrightText($module)
	{
		echo '<div id="vina-copyright'.$module->id.'">© Free <a href="http://vinagecko.com/joomla-modules" title="Free Joomla! 3 Modules">Joomla! 3 Modules</a>- by <a href="http://vinagecko.com/" title="Beautiful Joomla! 3 Templates and Powerful Joomla! 3 Modules, Plugins.">VinaGecko.com</a></div>';
	}
}