<?php
/*
# ------------------------------------------------------------------------
# Vina Tag Cloud for K2 for Joomla 3
# ------------------------------------------------------------------------
# Copyright(C) 2014 www.VinaGecko.com. All Rights Reserved.
# @license http://www.gnu.org/licenseses/gpl-3.0.html GNU/GPL
# Author: VinaGecko.com
# Websites: http://vinagecko.com
# Forum: http://vinagecko.com/forum/
# ------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

// Include the syndicate functions only once
require_once (dirname(__FILE__) . DS . 'helper.php');

$list = modVinaTagCloudK2Helper::tagCloud($params);

if(!count($list)) {
	echo JTEXT::_('VINA_TAGCLOUD_K2_NO_TAGS_FOUND');
	return;
}

// Get module params
$moduleclass_sfx	= htmlspecialchars($params->get('moduleclass_sfx'));
$displayCount	= $params->get('displayCount', 1);
$moduleWidth	= $params->get('moduleWidth', 300);
$moduleHeight	= $params->get('moduleHeight', 300);
$modulePadding	= $params->get('modulePadding', '10px 10px 10px 10px');
$useBackground	= $params->get('useBackground', 1);
$bgColor		= $params->get('bgColor', '#003399');
$interval		= $params->get('interval', 30);
$maxSpeed		= $params->get('maxSpeed', 0.05);
$minSpeed		= $params->get('minSpeed', 0.0);
$dragControl	= $params->get('dragControl', 0);
$fadeIn			= $params->get('fadeIn', 0);
$minBrightness	= $params->get('minBrightness', 0.1);
$maxBrightness	= $params->get('maxBrightness', 1);
$textColour		= $params->get('textColour', '#ff99ff');
$textHeight		= $params->get('textHeight', 15);
$outlineColour	= $params->get('outlineColour', '#ffff99');
$outlineMethod	= $params->get('outlineMethod', 'outline');
$animTiming		= $params->get('animTiming', 'Smooth');
$reverse		= $params->get('reverse', 1);
$bgImage		= $params->get('bgImage', NULL);
$shape			= $params->get('shape', 'sphere');
if($bgImage != '') {
	if(strpos($bgImage, 'http://') === FALSE) {
		$bgImage = JURI::base() . $bgImage;
	}
}
$outlineThickness	= $params->get('outlineThickness', 2);
$outlineOffset		= $params->get('outlineOffset', 5);
$linkTarget			= $params->get('linkTarget', 0);
$minTextSize		= $params->get('minTextSize', 12);
$maxTextSize		= $params->get('maxTextSize', 48);

// get max number of item
$maxItem = 0;
foreach ($list as $item) {
	$temp	 = $item->count;
	$maxItem = ($temp > $maxItem) ? $temp : $maxItem;
}

$fontSize = floor($maxTextSize/$maxItem);

require JModuleHelper::getLayoutPath('mod_vina_tagcloud_k2', $params->get('layout', 'default'));
modVinaTagCloudK2Helper::getCopyrightText($module);