<?php
/*
# ------------------------------------------------------------------------
# Vina Tag Cloud for K2 for Joomla 3
# ------------------------------------------------------------------------
# Copyright(C) 2014 www.VinaGecko.com. All Rights Reserved.
# @license http://www.gnu.org/licenseses/gpl-3.0.html GNU/GPL
# Author: VinaGecko.com
# Websites: http://vinagecko.com
# Forum: http://vinagecko.com/forum/
# ------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

$doc = JFactory::getDocument();
$doc->addScript('modules/mod_vina_tagcloud_k2/assets/js/tag-canvas.js', 'text/javascript');
?>
<style type="text/css">
#vina-tagcloud-k2-canvas<?php echo $module->id; ?> {
	padding: <?php echo $modulePadding; ?>;
	<?php echo ($bgImage != '') ? 'background: url('.$bgImage.') repeat scroll 0 0;' : ''; ?>
	<?php echo ($useBackground) ? 'background-color:' . $bgColor : '';?>
}
#vina-copyright<?php echo $module->id; ?> {
	font-size: 12px;
	<?php if(!$params->get('copyRightText', 0)) : ?>
	height: 1px;
	overflow: hidden;
	<?php endif; ?>
}
</style>
<div class="tagspopular<?php echo $moduleclass_sfx; ?>">
	<div id="vina-tagcloud-k2-canvas-wrapper<?php echo $module->id; ?>" class="vina-tagcloud-k2-canvas">
		<canvas width="<?php echo $moduleWidth; ?>" height="<?php echo $moduleHeight; ?>" id="vina-tagcloud-k2-canvas<?php echo $module->id; ?>">
			<p>Anything in here will be replaced on browsers that support the canvas element</p>
		</canvas>
    </div>
	<div style="display: none;" id="vina-tagcloud-k2<?php echo $module->id; ?>">
		<ul>
			<?php
			foreach ($list as $item) : 
				$noItem = $item->count;
				$xSize	= $noItem ? $noItem : 1;
			?>
			<li>
				<?php if($linkTarget == 1) : ?>
				<a style="font-size:<?php echo $xSize * $fontSize; ?>px" href="<?php echo $item->link; ?>" target="_blank">
					<?php echo htmlspecialchars($item->tag); ?> <?php if ($displayCount) : ?>(<?php echo $item->count; ?>)<?php endif; ?>
				</a>
				<?php elseif($linkTarget == 2) : ?>
				<a style="font-size:<?php echo $xSize * $fontSize; ?>px" href="<?php echo $item->link; ?>" onclick="window.open(this.href, '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550'); return false">
					<?php echo htmlspecialchars($item->tag); ?> <?php if ($displayCount) : ?>(<?php echo $item->count; ?>)<?php endif; ?>
				</a>
				<?php else : ?>
				<a style="font-size:<?php echo $xSize * $fontSize; ?>px" href="<?php echo $item->link; ?>">
					<?php echo htmlspecialchars($item->tag); ?> <?php if ($displayCount) : ?>(<?php echo $item->count; ?>)<?php endif; ?>
				</a>
				<?php endif; ?>
			</li>
			<?php endforeach; ?>
		</ul>
	</div>
</div>
<script type="text/javascript">
jQuery(document).ready(function($) {
	if(!$('#vina-tagcloud-k2-canvas<?php echo $module->id; ?>').tagcanvas({
		interval: 			<?php echo $interval; ?>,
		maxSpeed: 			<?php echo $maxSpeed; ?>,
		minSpeed: 			<?php echo $minSpeed; ?>,
		dragControl: 		<?php echo ($dragControl) ? 'true' : 'false'; ?>,
		fadeIn: 			<?php echo $fadeIn; ?>,
		minBrightness: 		<?php echo $minBrightness; ?>,
		maxBrightness: 		<?php echo $maxBrightness; ?>,
		textColour: 		'<?php echo $textColour; ?>',
		textHeight: 		<?php echo $textHeight; ?>,
		outlineColour: 		'<?php echo $outlineColour; ?>',
		outlineMethod: 		'<?php echo $outlineMethod; ?>',
		outlineThickness: 	<?php echo $outlineThickness; ?>,
		outlineOffset: 		<?php echo $outlineOffset; ?>,
		animTiming: 		'<?php echo $animTiming; ?>',
		reverse: 			<?php echo ($reverse) ? 'true' : 'false'; ?>,
		shape:				'<?php echo $shape; ?>',
		weight: 			true,
		weightSizeMin: 		<?php echo $minTextSize; ?>,
		weightSizeMax: 		<?php echo $maxTextSize; ?>,
	}, 'vina-tagcloud-k2<?php echo $module->id; ?>')) {
		$('#vina-tagcloud-k2-canvas-wrapper<?php echo $module->id; ?>').hide();
	}
});
</script>